package it.unibo.tw0809.ui;
import it.unibo.tw0809.xml.IValidator;

/**
 * This example found on
 * http://www.ibm.com/developerworks/xml/library/x-javaxmlvalidapi.html
 *
 * @author Elliotte Rusty Harold (elharo@metalab.unc.edu), Adjunct Professor, Polytechnic University
 */
public class CommandLineUI {

	public static void main(String[] args) 
	throws Exception {
		
		ArgsParser argsParser = new ArgsParser(args);
		
		if ( ! argsParser.checkArgs() ) {
			System.out.println(argsParser.getMessage());
			return;
		}

		IValidator validator = argsParser.getValidator();
			
		String document_filename = args[0];
		String definition_filename = args[1];
		
		if ( validator.validate(document_filename,definition_filename) )
			System.out.println("Success!");
		else
			System.out.println("Failure.");
		
		System.out.println("--------------------------------------------------------");
		System.out.println(validator.getResult());
		
	}

}
