package it.unibo.tw0809.ui;

import it.unibo.tw0809.xml.IValidator;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class GraphicalUI
extends CommandLineUI {

	/**
	 * @param args
	 */
	public static void main(String[] args)
	throws Exception {

		JFrame frame = new JFrame();
	    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	    JOptionPane.showMessageDialog(
		    	frame, 
				"You will be requested to specify:\n\n" +
				" - an XML filename (path can be either absolute or relative to your current working directory)\n" + 
				" - an XSD or DTD filename (path can be either absolute or relative to you current working directory [*] )\n" +
				" - a parser type (accepted values are 'dom' or 'sax')\n" +
				"\n" +
				"[*] Notice: when using DOM to apply a schema definition,\n" + 
				"relative path to the XSD file must refer\n" +
				"to the location of the XML file to validate,\n" + 
				"and not to your current working directory!!",
		    	"Welcome to XMLValidatorPlus", 
		    	JOptionPane.INFORMATION_MESSAGE
			);
	    
	    String document_filename = (args.length >= 1) ? args[0] : null;
	    String definition_filename = (args.length >= 2) ? args[1] : null;
	    String parser_type = null;
	    ArgsParser argsParser = null;
	    boolean loop = true;
	    
	    while ( loop ) {

	    	document_filename = 
		    	JOptionPane.showInputDialog(
		    		frame,
		    		"Document file:", 
		    		document_filename
		    	);
		    
	    	definition_filename = 
		    	JOptionPane.showInputDialog(
		    		frame, 
		    		"Definition file:", 
		    		definition_filename
		    	);
				  
		    Object[] options = {"SAX","DOM"};
		    int n = 
		    	JOptionPane.showOptionDialog(
		    			frame, 
		    			"Select parser type:", 
		    			"Parser choice",
		    			JOptionPane.YES_NO_OPTION, 
		    			JOptionPane.QUESTION_MESSAGE,
		    			null,
		    			options,
		    			options[0]
		    	);
		    parser_type = "sax";
		    if ( n == 1 ) 
		    	parser_type = "dom";
	
			argsParser = new ArgsParser(new String[]{ document_filename, definition_filename, parser_type });

		    if ( argsParser.checkArgs() ) {
		    	loop = false;
		    }
		    else {
			    JOptionPane.showMessageDialog(
			    	frame, 
			    	argsParser.getMessage(),
			    	"Error!", 
			    	JOptionPane.ERROR_MESSAGE
			    );
			}
	    }

	    IValidator validator = argsParser.getValidator();

	    JOptionPane.showMessageDialog(
	    	frame, 
			"..." + document_filename + " against " + definition_filename + " by means of " + parser_type + " parser.",
	    	"About to validate...", 
	    	JOptionPane.INFORMATION_MESSAGE
		);

	    boolean success = validator.validate(document_filename,definition_filename);
	    
	    if ( success ) {
		    JOptionPane.showMessageDialog(
		    	frame, 
				validator.getResult(),
		    	"Success!", 
		    	JOptionPane.INFORMATION_MESSAGE
			);
		}
	    else {
		    JOptionPane.showMessageDialog(
		    	frame, 
		    	validator.getResult(),
		    	"Failure!", 
		    	JOptionPane.ERROR_MESSAGE
			);
	    }
	
	}

}
