package it.unibo.tw0809.util;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

public class MyHandler 
extends DefaultHandler
implements ErrorHandler {
	
	private StringBuffer result;
	private boolean foundErrors = false;
	
	// ----------------------------
	
	public MyHandler(StringBuffer result) {
		this.result = result;
	}

	// ----------------------------
	
	public boolean success() {
		return ! foundErrors;
	}

	// ----------------------------

	public void warning(SAXParseException e) throws SAXException {
		result.append("Warning: \n"); 
		appendMoreInfo(e);
	}
	
	public void error(SAXParseException e) throws SAXException {
		result.append("Error: \n"); 
		appendMoreInfo(e);
		foundErrors = true;
	}
	
	public void fatalError(SAXParseException e) throws SAXException {
    	result.append("Fatal error: \n"); 
    	appendMoreInfo(e);
		foundErrors = true;
	}
	
	// -------------------------------
	
	private void appendMoreInfo(SAXParseException e) {
		result.append("   Public ID: "+e.getPublicId() + "\n");
		result.append("   System ID: "+e.getSystemId() + "\n");
		result.append("   Line number: "+e.getLineNumber() + "\n");
		result.append("   Column number: "+e.getColumnNumber() + "\n");
		result.append("   Message: "+e.getMessage() + "\n");
    }

}
