package it.unibo.tw0809.xml;

import it.unibo.tw0809.util.FileUtil;
import it.unibo.tw0809.util.MyHandler;
import it.unibo.tw0809.util.MyResolver;

import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

/**
 * This example found on
 * http://www.herongyang.com/xml/dtd_validation.html
 * 
 * @author Dr. Herong Yang
 * 
 * modified by Pisi
 */
public class DTD_DOM_Validator 
implements IValidator {

	public static String default_xml_filename = "validation/prova.xml";
	public static String default_dtd_filename = "validation/prova.dtd";

	// ---------------------------------------

	private boolean verbose = true;

	private StringBuffer result = new StringBuffer();
	
	// ---------------------------------------

	public void setVerbose(boolean verbose) {
		this.verbose = verbose;
	}

	public String getResult() {
		return this.result.toString();
	}

	public boolean validate(String xml_filename, String absolute_dtd_filename) {

		try {
			
			if ( verbose ) FileUtil.printFileContent(absolute_dtd_filename);
			if ( verbose ) FileUtil.printFileContent(xml_filename);

			File x = new File(xml_filename);
	        DocumentBuilderFactory f = DocumentBuilderFactory.newInstance();
	        f.setValidating(true); // Default is false

	        DocumentBuilder b = f.newDocumentBuilder();
			 
			 // ErrorHandler h = new DefaultHandler();
			MyHandler myHandler = new MyResolver(this.result, absolute_dtd_filename);
			b.setErrorHandler(myHandler);
			
			/*Document d = */b.parse(x);
			boolean success = myHandler.success(); 
			if ( success )
			    this.result.append(xml_filename + " is valid.");
			else
			    this.result.insert(0, xml_filename + " is not valid because of").append("\n");
			return success;

		}
		catch (Exception e) {
			this.result = new StringBuffer();
			this.result.append(e.getClass().getCanonicalName()).append("\n").append(e.getMessage());
		    return false;
		}
	
	}

}
