package it.unibo.tw0809.xml;

import it.unibo.tw0809.util.FileUtil;
import it.unibo.tw0809.util.MyHandler;
import it.unibo.tw0809.util.MyResolver;

import java.io.FileInputStream;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * This example found on
 * http://www.herongyang.com/xml/dtd_validation.html
 * 
 * @author Dr. Herong Yang
 * 
 * modified by Pisi
 */
public class DTD_SAX_Validator 
implements IValidator {

	public static String default_xml_filename = "validation/prova.xml";
	public static String default_dtd_filename = "validation/prova.dtd";

	// ---------------------------------------

	private boolean verbose = true;

	private StringBuffer result = new StringBuffer();
	
	// ---------------------------------------

	public void setVerbose(boolean verbose) {
		this.verbose = verbose;
	}

	public String getResult() {
		return this.result.toString();
	}

	public boolean validate(String xml_filename, String absolute_dtd_filename) {

		try {
			
			if ( verbose ) FileUtil.printFileContent(absolute_dtd_filename);
			if ( verbose ) FileUtil.printFileContent(xml_filename);

			FileInputStream x = new FileInputStream(xml_filename);
		    
			SAXParserFactory f = SAXParserFactory.newInstance();
			f.setValidating(true); // Default is false         
		    
			SAXParser p = f.newSAXParser();
		    MyHandler h = new MyResolver(this.result,absolute_dtd_filename);
		    p.parse(x,h);
		    
			boolean success = h.success(); 
			if ( success )
			    this.result.append(xml_filename + " is valid.");
			else
			    this.result.insert(0, xml_filename + " is not valid because of").append("\n");
			return success;

		}
		catch (Exception e) {
			this.result = new StringBuffer();
			this.result.append(e.getClass().getCanonicalName()).append("\n").append(e.getMessage());
		    return false;
		}
	
	}

}
