package it.unibo.tw0809.test;

import it.unibo.tw0809.ui.ArgsParser;
import it.unibo.tw0809.xml.DTD_DOM_Validator;
import it.unibo.tw0809.xml.DTD_SAX_Validator;
import it.unibo.tw0809.xml.XSD_DOM_Validator;
import it.unibo.tw0809.xml.XSD_SAX_Validator;
import junit.framework.JUnit4TestAdapter;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ArgsParserTest {

	public static junit.framework.Test suite() {
		return new JUnit4TestAdapter(ArgsParserTest.class);
	}
	
	// -------------------------------------------------
	// --- Initialization ------------------------------
	// -------------------------------------------------
	
	@BeforeClass
	public static void thisWorkBeforeAllTests() 
	throws Exception {
	}

	@Before
	public void thisIsTheOldSetUp() 
	throws Exception {
	}

	@After
	public void thisIsTheOldTearDown() 
	throws Exception {
	}

	@AfterClass
	public static void thisWorkAfterAllTests() 
	throws Exception {
	}

	// -------------------------------------------------
	// --- Tests ---------------------------------------
	// -------------------------------------------------

	@Test
	public void get_XSD_SAX_Validator() {
		String[] args = { "my.xml","my.xsd","sax" };
		ArgsParser argsParser = new ArgsParser(args);
		Assert.assertTrue(argsParser.getValidator() instanceof XSD_SAX_Validator );
//			
//		}
//		boolean expected = true;
//		boolean actual = (1==1);
//		Assert.assertEquals("Yes, they are equals!",expected,actual);
	}

	@Test
	public void get_XSD_DOM_Validator() {
		String[] args = { "my.xml","my.xsd","dom" };
		ArgsParser argsParser = new ArgsParser(args);
		Assert.assertTrue(argsParser.getValidator() instanceof XSD_DOM_Validator );
	}

	@Test
	public void get_DTD_SAX_Validator() {
		String[] args = { "my.xml","my.dtd","sax" };
		ArgsParser argsParser = new ArgsParser(args);
		Assert.assertTrue(argsParser.getValidator() instanceof DTD_SAX_Validator );
	}

	@Test
	public void get_DTD_DOM_Validator() {
		String[] args = { "my.xml","my.dtd","dom" };
		ArgsParser argsParser = new ArgsParser(args);
		Assert.assertTrue(argsParser.getValidator() instanceof DTD_DOM_Validator );
	}

}
