package it.unibo.tw0809.test;

import it.unibo.tw0809.ui.ArgsParser;
import junit.framework.JUnit4TestAdapter;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ValidatorTest {

	public static junit.framework.Test suite() {
		return new JUnit4TestAdapter(ValidatorTest.class);
	}
	
	// -------------------------------------------------
	// --- Initialization ------------------------------
	// -------------------------------------------------
	
	@BeforeClass
	public static void thisWorkBeforeAllTests() 
	throws Exception {
	}

	@Before
	public void thisIsTheOldSetUp() 
	throws Exception {
	}

	@After
	public void thisIsTheOldTearDown() 
	throws Exception {
	}

	@AfterClass
	public static void thisWorkAfterAllTests() 
	throws Exception {
	}

	// -------------------------------------------------
	// --- Tests ---------------------------------------
	// -------------------------------------------------

	@Test
	public void right_XSD_SAX_Validation() {
//		String doc = "validation/prova-xsd.xml";
//		String doc = "validation/prova-noNamespace.xml";
		String doc = "validation/prova.xml";
		String def = "validation/prova.xsd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.SAX});
		Assert.assertTrue(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void right_XSD_DOM_Validation() {
//		String doc = "validation/prova-xsd.xml";
//		String doc = "validation/prova-noNamespace.xml";
		String doc = "validation/prova.xml";
		String def = "prova.xsd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.DOM});
		Assert.assertTrue(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void right_DTD_SAX_Validation() {
		String doc = "validation/prova-dtd.xml";
		String def = "validation/prova.dtd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.SAX});
		Assert.assertTrue(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void right_DTD_DOM_Validation() {
		String doc = "validation/prova-dtd.xml";
		String def = "validation/prova.dtd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.DOM});
		Assert.assertTrue(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void wrong_XSD_SAX_Validation() {
		String doc = "validation/invalid.xml";
		String def = "validation/prova.xsd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.SAX});
		Assert.assertFalse(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void wrong_XSD_DOM_Validation() {
		String doc = "validation/invalid.xml";
		String def = "prova.xsd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.DOM});
		Assert.assertFalse(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void wrong_DTD_SAX_Validation() {
		String doc = "validation/invalid-dtd.xml";
		String def = "validation/prova.dtd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.SAX});
		Assert.assertFalse(argsParser.getValidator().validate(doc,def));
	}

	@Test
	public void wrong_DTD_DOM_Validation() {
		String doc = "validation/invalid-dtd.xml";
		String def = "validation/prova.dtd";
		ArgsParser argsParser = new ArgsParser(new String[] { doc, def, ArgsParser.DOM});
		Assert.assertFalse(argsParser.getValidator().validate(doc,def));
	}

}
